import CharacterTypeRepository from '#repositories/characterTypeRepository'
import { BaseEvent } from '#application/base/baseEvent'
import { CharacterType } from '#entities/characterType'

interface IPayload {}

export default class CharacterTypeListEvent extends BaseEvent {
  public listen(): void {
    this.socket.on('gm:characterType:list', this.handleEvent.bind(this))
  }

  private async handleEvent(data: IPayload, callback: (response: CharacterType[]) => void): Promise<void> {
    try {
      if (!(await this.isCharacterGM())) return

      const items = await CharacterTypeRepository.getAll()
      return callback(items)
    } catch (error) {
      this.logger.error('gm:characterType:list error', error)
      return callback([])
    }
  }
}
