import { Sprite } from '@prisma/client'

import { BaseEvent } from '#application/base/baseEvent'
import SpriteRepository from '#repositories/spriteRepository'

interface IPayload {}

export default class SpriteListEvent extends BaseEvent {
  public listen(): void {
    this.socket.on('gm:sprite:list', this.handleEvent.bind(this))
  }

  private async handleEvent(data: IPayload, callback: (response: Sprite[]) => void): Promise<void> {
    if (!(await this.isCharacterGM())) return

    // get all sprites
    const sprites = await SpriteRepository.getAll()
    callback(sprites)
  }
}
